"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class AccountQueryRequest(google.protobuf.message.Message):
    """AccountQueryRequest is the request type for the Query/AccountQuery RPC"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TARGET_FIELD_NUMBER: builtins.int
    REQUEST_FIELD_NUMBER: builtins.int
    target: builtins.str
    """target defines the account to be queried."""
    @property
    def request(self) -> google.protobuf.any_pb2.Any:
        """request defines the query message being sent to the account."""

    def __init__(
        self,
        *,
        target: builtins.str = ...,
        request: google.protobuf.any_pb2.Any | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["request", b"request"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["request", b"request", "target", b"target"]) -> None: ...

global___AccountQueryRequest = AccountQueryRequest

@typing.final
class AccountQueryResponse(google.protobuf.message.Message):
    """AccountQueryResponse is the response type for the Query/AccountQuery RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESPONSE_FIELD_NUMBER: builtins.int
    @property
    def response(self) -> google.protobuf.any_pb2.Any:
        """response defines the query response of the account."""

    def __init__(
        self,
        *,
        response: google.protobuf.any_pb2.Any | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["response", b"response"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["response", b"response"]) -> None: ...

global___AccountQueryResponse = AccountQueryResponse

@typing.final
class SchemaRequest(google.protobuf.message.Message):
    """SchemaResponse is the response type for the Query/Schema RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACCOUNT_TYPE_FIELD_NUMBER: builtins.int
    account_type: builtins.str
    """account_type defines the account type to query the schema for."""
    def __init__(
        self,
        *,
        account_type: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["account_type", b"account_type"]) -> None: ...

global___SchemaRequest = SchemaRequest

@typing.final
class SchemaResponse(google.protobuf.message.Message):
    """SchemaResponse is the response type for the Query/Schema RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class Handler(google.protobuf.message.Message):
        """Handler defines a schema descriptor for a handler.
        Where request and response are names that can be used to lookup the
        reflection descriptor.
        """

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        REQUEST_FIELD_NUMBER: builtins.int
        RESPONSE_FIELD_NUMBER: builtins.int
        request: builtins.str
        """request is the request name"""
        response: builtins.str
        """response is the response name"""
        def __init__(
            self,
            *,
            request: builtins.str = ...,
            response: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["request", b"request", "response", b"response"]) -> None: ...

    INIT_SCHEMA_FIELD_NUMBER: builtins.int
    EXECUTE_HANDLERS_FIELD_NUMBER: builtins.int
    QUERY_HANDLERS_FIELD_NUMBER: builtins.int
    @property
    def init_schema(self) -> global___SchemaResponse.Handler:
        """init_schema defines the schema descriptor for the Init account method."""

    @property
    def execute_handlers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___SchemaResponse.Handler]:
        """execute_handlers defines the schema descriptor for the Execute account method."""

    @property
    def query_handlers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___SchemaResponse.Handler]:
        """query_handlers defines the schema descriptor for the Query account method."""

    def __init__(
        self,
        *,
        init_schema: global___SchemaResponse.Handler | None = ...,
        execute_handlers: collections.abc.Iterable[global___SchemaResponse.Handler] | None = ...,
        query_handlers: collections.abc.Iterable[global___SchemaResponse.Handler] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["init_schema", b"init_schema"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["execute_handlers", b"execute_handlers", "init_schema", b"init_schema", "query_handlers", b"query_handlers"]) -> None: ...

global___SchemaResponse = SchemaResponse

@typing.final
class AccountTypeRequest(google.protobuf.message.Message):
    """AccountTypeRequest is the request type for the Query/AccountType RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESS_FIELD_NUMBER: builtins.int
    address: builtins.str
    """address defines the address to query the account type for."""
    def __init__(
        self,
        *,
        address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["address", b"address"]) -> None: ...

global___AccountTypeRequest = AccountTypeRequest

@typing.final
class AccountTypeResponse(google.protobuf.message.Message):
    """AccountTypeResponse is the response type for the Query/AccountType RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACCOUNT_TYPE_FIELD_NUMBER: builtins.int
    account_type: builtins.str
    """account_type defines the account type for the address."""
    def __init__(
        self,
        *,
        account_type: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["account_type", b"account_type"]) -> None: ...

global___AccountTypeResponse = AccountTypeResponse

@typing.final
class AccountNumberRequest(google.protobuf.message.Message):
    """AccountNumberRequest returns the account number given the address."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESS_FIELD_NUMBER: builtins.int
    address: builtins.str
    """address is the address of the account we want to know the number of."""
    def __init__(
        self,
        *,
        address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["address", b"address"]) -> None: ...

global___AccountNumberRequest = AccountNumberRequest

@typing.final
class AccountNumberResponse(google.protobuf.message.Message):
    """AccountNumberResponse is the response returned when querying the
    account number by address.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NUMBER_FIELD_NUMBER: builtins.int
    number: builtins.int
    """number is the account number of the provided address."""
    def __init__(
        self,
        *,
        number: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["number", b"number"]) -> None: ...

global___AccountNumberResponse = AccountNumberResponse
