"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import cosmos.base.v1beta1.coin_pb2
import cosmos.tx.v1beta1.tx_pb2
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MsgInit(google.protobuf.message.Message):
    """MsgInit defines the Create request type for the Msg/Create RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SENDER_FIELD_NUMBER: builtins.int
    ACCOUNT_TYPE_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    FUNDS_FIELD_NUMBER: builtins.int
    sender: builtins.str
    """sender is the address of the sender of this message."""
    account_type: builtins.str
    """account_type is the type of the account to be created."""
    @property
    def message(self) -> google.protobuf.any_pb2.Any:
        """message is the message to be sent to the account."""

    @property
    def funds(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """funds contains the coins that the account wants to
        send alongside the request.
        """

    def __init__(
        self,
        *,
        sender: builtins.str = ...,
        account_type: builtins.str = ...,
        message: google.protobuf.any_pb2.Any | None = ...,
        funds: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["message", b"message"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["account_type", b"account_type", "funds", b"funds", "message", b"message", "sender", b"sender"]) -> None: ...

global___MsgInit = MsgInit

@typing.final
class MsgInitResponse(google.protobuf.message.Message):
    """MsgInitResponse defines the Create response type for the Msg/Create RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACCOUNT_ADDRESS_FIELD_NUMBER: builtins.int
    RESPONSE_FIELD_NUMBER: builtins.int
    account_address: builtins.str
    """account_address is the address of the newly created account."""
    @property
    def response(self) -> google.protobuf.any_pb2.Any:
        """response is the response returned by the account implementation."""

    def __init__(
        self,
        *,
        account_address: builtins.str = ...,
        response: google.protobuf.any_pb2.Any | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["response", b"response"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["account_address", b"account_address", "response", b"response"]) -> None: ...

global___MsgInitResponse = MsgInitResponse

@typing.final
class MsgExecute(google.protobuf.message.Message):
    """MsgExecute defines the Execute request type for the Msg/Execute RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SENDER_FIELD_NUMBER: builtins.int
    TARGET_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    FUNDS_FIELD_NUMBER: builtins.int
    sender: builtins.str
    """sender is the address of the sender of this message."""
    target: builtins.str
    """target is the address of the account to be executed."""
    @property
    def message(self) -> google.protobuf.any_pb2.Any:
        """message is the message to be sent to the account."""

    @property
    def funds(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """funds contains the coins that the account wants to
        send alongside the request.
        """

    def __init__(
        self,
        *,
        sender: builtins.str = ...,
        target: builtins.str = ...,
        message: google.protobuf.any_pb2.Any | None = ...,
        funds: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["message", b"message"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["funds", b"funds", "message", b"message", "sender", b"sender", "target", b"target"]) -> None: ...

global___MsgExecute = MsgExecute

@typing.final
class MsgExecuteResponse(google.protobuf.message.Message):
    """MsgExecuteResponse defines the Execute response type for the Msg/Execute RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESPONSE_FIELD_NUMBER: builtins.int
    @property
    def response(self) -> google.protobuf.any_pb2.Any:
        """response is the response returned by the account implementation."""

    def __init__(
        self,
        *,
        response: google.protobuf.any_pb2.Any | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["response", b"response"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["response", b"response"]) -> None: ...

global___MsgExecuteResponse = MsgExecuteResponse

@typing.final
class MsgExecuteBundle(google.protobuf.message.Message):
    """-------- Account Abstraction ---------

    MsgExecuteBundle defines the ExecuteBundle request type for the Msg/ExecuteBundle RPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    BUNDLER_FIELD_NUMBER: builtins.int
    TXS_FIELD_NUMBER: builtins.int
    bundler: builtins.str
    """bundler defines the entity going through the standard TX flow
    to execute one or multiple UserOperations on behalf of others.
    """
    @property
    def txs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.tx.v1beta1.tx_pb2.TxRaw]:
        """txs defines the txs to execute on behalf of other users."""

    def __init__(
        self,
        *,
        bundler: builtins.str = ...,
        txs: collections.abc.Iterable[cosmos.tx.v1beta1.tx_pb2.TxRaw] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["bundler", b"bundler", "txs", b"txs"]) -> None: ...

global___MsgExecuteBundle = MsgExecuteBundle

@typing.final
class BundledTxResponse(google.protobuf.message.Message):
    """BundledTxResponse defines the response of a bundled tx."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EXEC_RESPONSES_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def exec_responses(self) -> google.protobuf.any_pb2.Any: ...
    def __init__(
        self,
        *,
        exec_responses: google.protobuf.any_pb2.Any | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["exec_responses", b"exec_responses"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "exec_responses", b"exec_responses"]) -> None: ...

global___BundledTxResponse = BundledTxResponse

@typing.final
class MsgExecuteBundleResponse(google.protobuf.message.Message):
    """MsgExecuteBundleResponse defines the ExecuteBundle response type for the Msg/ExecuteBundle RPC method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESPONSES_FIELD_NUMBER: builtins.int
    @property
    def responses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BundledTxResponse]:
        """responses is the list of responses returned by the account implementations."""

    def __init__(
        self,
        *,
        responses: collections.abc.Iterable[global___BundledTxResponse] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["responses", b"responses"]) -> None: ...

global___MsgExecuteBundleResponse = MsgExecuteBundleResponse
