"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Since: cosmos-sdk 0.46"""

import builtins
import collections.abc
import cosmos.base.v1beta1.coin_pb2
import cosmos.gov.v1.gov_pb2
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.timestamp_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MsgSubmitProposal(google.protobuf.message.Message):
    """MsgSubmitProposal defines an sdk.Msg type that supports submitting arbitrary
    proposal Content.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESSAGES_FIELD_NUMBER: builtins.int
    INITIAL_DEPOSIT_FIELD_NUMBER: builtins.int
    PROPOSER_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    TITLE_FIELD_NUMBER: builtins.int
    SUMMARY_FIELD_NUMBER: builtins.int
    EXPEDITED_FIELD_NUMBER: builtins.int
    PROPOSAL_TYPE_FIELD_NUMBER: builtins.int
    proposer: builtins.str
    """proposer is the account address of the proposer."""
    metadata: builtins.str
    """metadata is any arbitrary metadata attached to the proposal."""
    title: builtins.str
    """title is the title of the proposal.

    Since: cosmos-sdk 0.47
    """
    summary: builtins.str
    """summary is the summary of the proposal

    Since: cosmos-sdk 0.47
    """
    expedited: builtins.bool
    """expedited defines if the proposal is expedited or not

    Since: cosmos-sdk 0.50
    Deprecated: Use the PROPOSAL_TYPE_EXPEDITED proposal type instead.
    When this field is set and no proposal_type is set, the proposal_type
    will be set to PROPOSAL_TYPE_EXPEDITED for backwards compatibility.
    """
    proposal_type: cosmos.gov.v1.gov_pb2.ProposalType.ValueType
    """proposal_type defines the type of proposal
    When not set defaults to PROPOSAL_TYPE_STANDARD

    Since: x/gov v1.0.0
    """
    @property
    def messages(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[google.protobuf.any_pb2.Any]:
        """messages are the arbitrary messages to be executed if proposal passes."""

    @property
    def initial_deposit(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """initial_deposit is the deposit value that must be paid at proposal submission."""

    def __init__(
        self,
        *,
        messages: collections.abc.Iterable[google.protobuf.any_pb2.Any] | None = ...,
        initial_deposit: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
        proposer: builtins.str = ...,
        metadata: builtins.str = ...,
        title: builtins.str = ...,
        summary: builtins.str = ...,
        expedited: builtins.bool = ...,
        proposal_type: cosmos.gov.v1.gov_pb2.ProposalType.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["expedited", b"expedited", "initial_deposit", b"initial_deposit", "messages", b"messages", "metadata", b"metadata", "proposal_type", b"proposal_type", "proposer", b"proposer", "summary", b"summary", "title", b"title"]) -> None: ...

global___MsgSubmitProposal = MsgSubmitProposal

@typing.final
class MsgSubmitProposalResponse(google.protobuf.message.Message):
    """MsgSubmitProposalResponse defines the Msg/SubmitProposal response type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["proposal_id", b"proposal_id"]) -> None: ...

global___MsgSubmitProposalResponse = MsgSubmitProposalResponse

@typing.final
class MsgExecLegacyContent(google.protobuf.message.Message):
    """MsgExecLegacyContent is used to wrap the legacy content field into a message.
    This ensures backwards compatibility with v1beta1.MsgSubmitProposal.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CONTENT_FIELD_NUMBER: builtins.int
    AUTHORITY_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority must be the gov module address."""
    @property
    def content(self) -> google.protobuf.any_pb2.Any:
        """content is the proposal's content."""

    def __init__(
        self,
        *,
        content: google.protobuf.any_pb2.Any | None = ...,
        authority: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["content", b"content"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "content", b"content"]) -> None: ...

global___MsgExecLegacyContent = MsgExecLegacyContent

@typing.final
class MsgExecLegacyContentResponse(google.protobuf.message.Message):
    """MsgExecLegacyContentResponse defines the Msg/ExecLegacyContent response type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgExecLegacyContentResponse = MsgExecLegacyContentResponse

@typing.final
class MsgVote(google.protobuf.message.Message):
    """MsgVote defines a message to cast a vote."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    VOTER_FIELD_NUMBER: builtins.int
    OPTION_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    voter: builtins.str
    """voter is the voter address for the proposal."""
    option: cosmos.gov.v1.gov_pb2.VoteOption.ValueType
    """option defines the vote option."""
    metadata: builtins.str
    """metadata is any arbitrary metadata attached to the Vote."""
    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        voter: builtins.str = ...,
        option: cosmos.gov.v1.gov_pb2.VoteOption.ValueType = ...,
        metadata: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "option", b"option", "proposal_id", b"proposal_id", "voter", b"voter"]) -> None: ...

global___MsgVote = MsgVote

@typing.final
class MsgVoteResponse(google.protobuf.message.Message):
    """MsgVoteResponse defines the Msg/Vote response type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgVoteResponse = MsgVoteResponse

@typing.final
class MsgVoteWeighted(google.protobuf.message.Message):
    """MsgVoteWeighted defines a message to cast a vote."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    VOTER_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    voter: builtins.str
    """voter is the voter address for the proposal."""
    metadata: builtins.str
    """metadata is any arbitrary metadata attached to the VoteWeighted."""
    @property
    def options(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.gov.v1.gov_pb2.WeightedVoteOption]:
        """options defines the weighted vote options."""

    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        voter: builtins.str = ...,
        options: collections.abc.Iterable[cosmos.gov.v1.gov_pb2.WeightedVoteOption] | None = ...,
        metadata: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "options", b"options", "proposal_id", b"proposal_id", "voter", b"voter"]) -> None: ...

global___MsgVoteWeighted = MsgVoteWeighted

@typing.final
class MsgVoteWeightedResponse(google.protobuf.message.Message):
    """MsgVoteWeightedResponse defines the Msg/VoteWeighted response type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgVoteWeightedResponse = MsgVoteWeightedResponse

@typing.final
class MsgDeposit(google.protobuf.message.Message):
    """MsgDeposit defines a message to submit a deposit to an existing proposal."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    DEPOSITOR_FIELD_NUMBER: builtins.int
    AMOUNT_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    depositor: builtins.str
    """depositor defines the deposit addresses from the proposals."""
    @property
    def amount(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """amount to be deposited by depositor."""

    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        depositor: builtins.str = ...,
        amount: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["amount", b"amount", "depositor", b"depositor", "proposal_id", b"proposal_id"]) -> None: ...

global___MsgDeposit = MsgDeposit

@typing.final
class MsgDepositResponse(google.protobuf.message.Message):
    """MsgDepositResponse defines the Msg/Deposit response type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgDepositResponse = MsgDepositResponse

@typing.final
class MsgUpdateParams(google.protobuf.message.Message):
    """MsgUpdateParams is the Msg/UpdateParams request type.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    PARAMS_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    @property
    def params(self) -> cosmos.gov.v1.gov_pb2.Params:
        """params defines the x/gov parameters to update.

        NOTE: All parameters must be supplied.
        """

    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        params: cosmos.gov.v1.gov_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "params", b"params"]) -> None: ...

global___MsgUpdateParams = MsgUpdateParams

@typing.final
class MsgUpdateParamsResponse(google.protobuf.message.Message):
    """MsgUpdateParamsResponse defines the response structure for executing a
    MsgUpdateParams message.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUpdateParamsResponse = MsgUpdateParamsResponse

@typing.final
class MsgCancelProposal(google.protobuf.message.Message):
    """MsgCancelProposal is the Msg/CancelProposal request type.

    Since: cosmos-sdk 0.50
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    PROPOSER_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    proposer: builtins.str
    """proposer is the account address of the proposer."""
    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        proposer: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["proposal_id", b"proposal_id", "proposer", b"proposer"]) -> None: ...

global___MsgCancelProposal = MsgCancelProposal

@typing.final
class MsgCancelProposalResponse(google.protobuf.message.Message):
    """MsgCancelProposalResponse defines the response structure for executing a
    MsgCancelProposal message.

    Since: cosmos-sdk 0.50
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    CANCELED_TIME_FIELD_NUMBER: builtins.int
    CANCELED_HEIGHT_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    canceled_height: builtins.int
    """canceled_height defines the block height at which the proposal is canceled."""
    @property
    def canceled_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """canceled_time is the time when proposal is canceled."""

    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        canceled_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        canceled_height: builtins.int = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["canceled_time", b"canceled_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["canceled_height", b"canceled_height", "canceled_time", b"canceled_time", "proposal_id", b"proposal_id"]) -> None: ...

global___MsgCancelProposalResponse = MsgCancelProposalResponse

@typing.final
class MsgSubmitMultipleChoiceProposal(google.protobuf.message.Message):
    """MsgSubmitMultipleChoiceProposal defines a message to submit a multiple choice proposal.

    Since: x/gov 1.0.0
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INITIAL_DEPOSIT_FIELD_NUMBER: builtins.int
    PROPOSER_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    TITLE_FIELD_NUMBER: builtins.int
    SUMMARY_FIELD_NUMBER: builtins.int
    VOTE_OPTIONS_FIELD_NUMBER: builtins.int
    proposer: builtins.str
    """proposer is the account address of the proposer."""
    metadata: builtins.str
    """metadata is any arbitrary metadata attached to the proposal."""
    title: builtins.str
    """title is the title of the proposal."""
    summary: builtins.str
    """summary is the summary of the proposal"""
    @property
    def initial_deposit(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """initial_deposit is the deposit value that must be paid at proposal submission."""

    @property
    def vote_options(self) -> cosmos.gov.v1.gov_pb2.ProposalVoteOptions:
        """vote_options defines the vote options for the proposal."""

    def __init__(
        self,
        *,
        initial_deposit: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
        proposer: builtins.str = ...,
        metadata: builtins.str = ...,
        title: builtins.str = ...,
        summary: builtins.str = ...,
        vote_options: cosmos.gov.v1.gov_pb2.ProposalVoteOptions | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["vote_options", b"vote_options"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["initial_deposit", b"initial_deposit", "metadata", b"metadata", "proposer", b"proposer", "summary", b"summary", "title", b"title", "vote_options", b"vote_options"]) -> None: ...

global___MsgSubmitMultipleChoiceProposal = MsgSubmitMultipleChoiceProposal

@typing.final
class MsgSubmitMultipleChoiceProposalResponse(google.protobuf.message.Message):
    """MsgSubmitMultipleChoiceProposalResponse defines the Msg/SubmitMultipleChoiceProposal response type.

    Since: x/gov 1.0.0
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["proposal_id", b"proposal_id"]) -> None: ...

global___MsgSubmitMultipleChoiceProposalResponse = MsgSubmitMultipleChoiceProposalResponse

@typing.final
class MsgUpdateMessageParams(google.protobuf.message.Message):
    """MsgUpdateMessageParams defines the Msg/UpdateMessageParams response type.

    Since: x/gov 1.0.0
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    MSG_URL_FIELD_NUMBER: builtins.int
    PARAMS_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    msg_url: builtins.str
    """msg_url is the url of the message to be updated."""
    @property
    def params(self) -> cosmos.gov.v1.gov_pb2.MessageBasedParams:
        """params are the new params to be set for the message."""

    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        msg_url: builtins.str = ...,
        params: cosmos.gov.v1.gov_pb2.MessageBasedParams | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "msg_url", b"msg_url", "params", b"params"]) -> None: ...

global___MsgUpdateMessageParams = MsgUpdateMessageParams

@typing.final
class MsgUpdateMessageParamsResponse(google.protobuf.message.Message):
    """MsgUpdateMessageParamsResponse defines the Msg/UpdateMessageParams response type.

    Since: x/gov 1.0.0
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUpdateMessageParamsResponse = MsgUpdateMessageParamsResponse

@typing.final
class MsgSudoExec(google.protobuf.message.Message):
    """MsgSudoExec defines a message to execute an inner message as the governance module.

    Since: x/gov 1.0.0
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    MSG_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    @property
    def msg(self) -> google.protobuf.any_pb2.Any:
        """msg is the arbitrary message to be executed."""

    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        msg: google.protobuf.any_pb2.Any | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["msg", b"msg"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "msg", b"msg"]) -> None: ...

global___MsgSudoExec = MsgSudoExec

@typing.final
class MsgSudoExecResponse(google.protobuf.message.Message):
    """MsgSudoExecResponse defines the Msg/SudoExec response type.

    Since: x/gov 1.0.0
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESULT_FIELD_NUMBER: builtins.int
    result: builtins.bytes
    """result is the response data from the executed message."""
    def __init__(
        self,
        *,
        result: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["result", b"result"]) -> None: ...

global___MsgSudoExecResponse = MsgSudoExecResponse
