"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import cosmos.base.v1beta1.coin_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import poktroll.application.params_pb2
import poktroll.application.types_pb2
import poktroll.shared.service_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MsgUpdateParams(google.protobuf.message.Message):
    """MsgUpdateParams is the Msg/UpdateParams request type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    PARAMS_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    @property
    def params(self) -> poktroll.application.params_pb2.Params:
        """TODO_IMPROVE(#322): The requirement to provide all params is adopted from the
        latest Cosmos SDK version. We should look into either improving this ourselves
        or seeing if it is on their roadmap.

        params defines the x/application parameters to update.
        NOTE: All parameters must be supplied.
        """

    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        params: poktroll.application.params_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authority", b"authority", "params", b"params"]) -> None: ...

global___MsgUpdateParams = MsgUpdateParams

@typing.final
class MsgUpdateParamsResponse(google.protobuf.message.Message):
    """MsgUpdateParamsResponse defines the response structure for executing a
    MsgUpdateParams message.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUpdateParamsResponse = MsgUpdateParamsResponse

@typing.final
class MsgStakeApplication(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESS_FIELD_NUMBER: builtins.int
    STAKE_FIELD_NUMBER: builtins.int
    SERVICES_FIELD_NUMBER: builtins.int
    address: builtins.str
    """The Bech32 address of the application."""
    @property
    def stake(self) -> cosmos.base.v1beta1.coin_pb2.Coin:
        """The total amount of uPOKT the application has staked. Must be ≥ to the current amount that the application has staked (if any)"""

    @property
    def services(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[poktroll.shared.service_pb2.ApplicationServiceConfig]:
        """The list of services this application is staked to request service for"""

    def __init__(
        self,
        *,
        address: builtins.str = ...,
        stake: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
        services: collections.abc.Iterable[poktroll.shared.service_pb2.ApplicationServiceConfig] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["stake", b"stake"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["address", b"address", "services", b"services", "stake", b"stake"]) -> None: ...

global___MsgStakeApplication = MsgStakeApplication

@typing.final
class MsgStakeApplicationResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APPLICATION_FIELD_NUMBER: builtins.int
    @property
    def application(self) -> poktroll.application.types_pb2.Application: ...
    def __init__(
        self,
        *,
        application: poktroll.application.types_pb2.Application | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["application", b"application"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["application", b"application"]) -> None: ...

global___MsgStakeApplicationResponse = MsgStakeApplicationResponse

@typing.final
class MsgUnstakeApplication(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESS_FIELD_NUMBER: builtins.int
    address: builtins.str
    def __init__(
        self,
        *,
        address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["address", b"address"]) -> None: ...

global___MsgUnstakeApplication = MsgUnstakeApplication

@typing.final
class MsgUnstakeApplicationResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUnstakeApplicationResponse = MsgUnstakeApplicationResponse

@typing.final
class MsgDelegateToGateway(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APP_ADDRESS_FIELD_NUMBER: builtins.int
    GATEWAY_ADDRESS_FIELD_NUMBER: builtins.int
    app_address: builtins.str
    """The Bech32 address of the application."""
    gateway_address: builtins.str
    """The Bech32 address of the gateway the application wants to delegate to."""
    def __init__(
        self,
        *,
        app_address: builtins.str = ...,
        gateway_address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["app_address", b"app_address", "gateway_address", b"gateway_address"]) -> None: ...

global___MsgDelegateToGateway = MsgDelegateToGateway

@typing.final
class MsgDelegateToGatewayResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APPLICATION_FIELD_NUMBER: builtins.int
    @property
    def application(self) -> poktroll.application.types_pb2.Application: ...
    def __init__(
        self,
        *,
        application: poktroll.application.types_pb2.Application | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["application", b"application"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["application", b"application"]) -> None: ...

global___MsgDelegateToGatewayResponse = MsgDelegateToGatewayResponse

@typing.final
class MsgUndelegateFromGateway(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APP_ADDRESS_FIELD_NUMBER: builtins.int
    GATEWAY_ADDRESS_FIELD_NUMBER: builtins.int
    app_address: builtins.str
    """The Bech32 address of the application."""
    gateway_address: builtins.str
    """The Bech32 address of the gateway the application wants to undelegate from."""
    def __init__(
        self,
        *,
        app_address: builtins.str = ...,
        gateway_address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["app_address", b"app_address", "gateway_address", b"gateway_address"]) -> None: ...

global___MsgUndelegateFromGateway = MsgUndelegateFromGateway

@typing.final
class MsgUndelegateFromGatewayResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___MsgUndelegateFromGatewayResponse = MsgUndelegateFromGatewayResponse

@typing.final
class MsgTransferApplication(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SOURCE_ADDRESS_FIELD_NUMBER: builtins.int
    DESTINATION_ADDRESS_FIELD_NUMBER: builtins.int
    source_address: builtins.str
    destination_address: builtins.str
    def __init__(
        self,
        *,
        source_address: builtins.str = ...,
        destination_address: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["destination_address", b"destination_address", "source_address", b"source_address"]) -> None: ...

global___MsgTransferApplication = MsgTransferApplication

@typing.final
class MsgTransferApplicationResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APPLICATION_FIELD_NUMBER: builtins.int
    @property
    def application(self) -> poktroll.application.types_pb2.Application: ...
    def __init__(
        self,
        *,
        application: poktroll.application.types_pb2.Application | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["application", b"application"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["application", b"application"]) -> None: ...

global___MsgTransferApplicationResponse = MsgTransferApplicationResponse

@typing.final
class MsgUpdateParam(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUTHORITY_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    AS_UINT64_FIELD_NUMBER: builtins.int
    AS_COIN_FIELD_NUMBER: builtins.int
    authority: builtins.str
    """authority is the address that controls the module (defaults to x/gov unless overwritten)."""
    name: builtins.str
    as_uint64: builtins.int
    @property
    def as_coin(self) -> cosmos.base.v1beta1.coin_pb2.Coin: ...
    def __init__(
        self,
        *,
        authority: builtins.str = ...,
        name: builtins.str = ...,
        as_uint64: builtins.int = ...,
        as_coin: cosmos.base.v1beta1.coin_pb2.Coin | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["asType", b"asType", "as_coin", b"as_coin", "as_uint64", b"as_uint64"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["asType", b"asType", "as_coin", b"as_coin", "as_uint64", b"as_uint64", "authority", b"authority", "name", b"name"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["asType", b"asType"]) -> typing.Literal["as_uint64", "as_coin"] | None: ...

global___MsgUpdateParam = MsgUpdateParam

@typing.final
class MsgUpdateParamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARAMS_FIELD_NUMBER: builtins.int
    @property
    def params(self) -> poktroll.application.params_pb2.Params: ...
    def __init__(
        self,
        *,
        params: poktroll.application.params_pb2.Params | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["params", b"params"]) -> None: ...

global___MsgUpdateParamResponse = MsgUpdateParamResponse
