"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
TODO_AUTOMATE: Add a CI workflow which detects .proto files with incompatible names (i.e. same as the package).
NB: This file CANNOT be named "application.proto" due to an as of yet unidentified
issue in how cosmos-proto generates the pulsar plugin output go source code.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import poktroll.application.types_pb2
import poktroll.shared.supplier_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class SessionHeader(google.protobuf.message.Message):
    """NOTE: Using signed integers for consistency with the cosmos SDK

    SessionHeader is a lightweight header for a session that can be passed around.
    It is the minimal amount of data required to hydrate & retrieve all data relevant to the session.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APPLICATION_ADDRESS_FIELD_NUMBER: builtins.int
    SERVICE_ID_FIELD_NUMBER: builtins.int
    SESSION_ID_FIELD_NUMBER: builtins.int
    SESSION_START_BLOCK_HEIGHT_FIELD_NUMBER: builtins.int
    SESSION_END_BLOCK_HEIGHT_FIELD_NUMBER: builtins.int
    application_address: builtins.str
    """The Bech32 address of the application."""
    service_id: builtins.str
    """The service id this session is for"""
    session_id: builtins.str
    """NOTE: session_id can be derived from the above values using on-chain but is included in the header for convenience
    A unique pseudoranom ID for this session
    """
    session_start_block_height: builtins.int
    """The height at which this session started"""
    session_end_block_height: builtins.int
    """Note that`session_end_block_height` is a derivative of (`start` + `num_blocks_per_session`)
    as goverened by on-chain params at the time of the session start.
    It is stored as an additional field to simplofy business logic in case
    the number of blocks_per_session changes during the session.
    The height at which this session ended, this is the last block of the session
    """
    def __init__(
        self,
        *,
        application_address: builtins.str = ...,
        service_id: builtins.str = ...,
        session_id: builtins.str = ...,
        session_start_block_height: builtins.int = ...,
        session_end_block_height: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["application_address", b"application_address", "service_id", b"service_id", "session_end_block_height", b"session_end_block_height", "session_id", b"session_id", "session_start_block_height", b"session_start_block_height"]) -> None: ...

global___SessionHeader = SessionHeader

@typing.final
class Session(google.protobuf.message.Message):
    """Session is a fully hydrated session object that contains all the information for the Session
    and its parcipants.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HEADER_FIELD_NUMBER: builtins.int
    SESSION_ID_FIELD_NUMBER: builtins.int
    SESSION_NUMBER_FIELD_NUMBER: builtins.int
    NUM_BLOCKS_PER_SESSION_FIELD_NUMBER: builtins.int
    APPLICATION_FIELD_NUMBER: builtins.int
    SUPPLIERS_FIELD_NUMBER: builtins.int
    session_id: builtins.str
    """A unique pseudoranom ID for this session"""
    session_number: builtins.int
    """The session number since genesis"""
    num_blocks_per_session: builtins.int
    """The number of blocks per session when this session started"""
    @property
    def header(self) -> global___SessionHeader:
        """The header of the session containing lightweight data"""

    @property
    def application(self) -> poktroll.application.types_pb2.Application:
        """A fully hydrated application object this session is for"""

    @property
    def suppliers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[poktroll.shared.supplier_pb2.Supplier]:
        """A fully hydrated set of servicers that are serving the application"""

    def __init__(
        self,
        *,
        header: global___SessionHeader | None = ...,
        session_id: builtins.str = ...,
        session_number: builtins.int = ...,
        num_blocks_per_session: builtins.int = ...,
        application: poktroll.application.types_pb2.Application | None = ...,
        suppliers: collections.abc.Iterable[poktroll.shared.supplier_pb2.Supplier] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["application", b"application", "header", b"header"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["application", b"application", "header", b"header", "num_blocks_per_session", b"num_blocks_per_session", "session_id", b"session_id", "session_number", b"session_number", "suppliers", b"suppliers"]) -> None: ...

global___Session = Session
